# 协作者与维护者

作为该语言的资深用户、该软件的专家、镜像站维护人员等，你总是对镜像站和源的可用状态拥有一手信息，我们需要你的帮助。如果想要达到最理想的维护状态，每一个 recipe 都需要有专人长时间维护。所以我们在这个文件记录的是愿意**长期**维护的人，如果是一次性提交代码，只需要在对应 recipe 的文件标头中记录即可。

一个 recipe 的协作者可分为：

1. **Director**

    负责人：对一个 recipe 完全负责，有写权限时可以直接推代码

    **目前项目的发展阶段还处于 *外行实现内行* 的情况，比如 Homebrew recipe，实现者根本不是 Homebrew 的真实用户，只是根据各种文档来实现，然后等待用户反馈。所以这里当前的实现者最多只能是 Maintainer，无法承担 Director 的责任**


2. **Maintainers**

    维护者：实现和持续维护 recipe，需要和 Director 一起 review 代码。可参考 [03-CONTRIBUTING.md](./03-CONTRIBUTING.md) 了解项目是如何进行提交和审阅代码的


3. **Observers**

    观察者：对该 target 和 recipe 持续反馈和关注的用户。如果你觉得你无法承担作为维护者的责任，可以退而求其次作为观察者积极参与其中

<br>

**项目采用申请制，请提交 PULL REQUEST 在该文件中添加自己，并在 [issue #130](https://github.com/RubyMetric/chsrc/issues/130) 留言。考虑到真正参与维护的人并不多，所以上述人数均不设限。**

`@`后面跟的是GitHub账户名，如 `@ccmywish`。若使用Gitee账号，则使用 `@gitee:ccmywish`。对我们来说，镜像站成员非常重要，所以请额外标注身份，如 `@username [TUNA]`

<br>


## Framework

1. **Director**: `@ccmywish` `@gitee:G_I_Y`
2. **Maintainers**:
3. **Observers**:

<br>


## 编程语言

### Ruby
1. **Director**: `@ccmywish`
2. **Maintainers**:
3. **Observers**:

### Python
1. **Director**:
2. **Maintainers**: `@ccmywish` `@happy-game`
3. **Observers**:

### NodeJS
1. **Director**:
2. **Maintainers**: `@ccmywish` `@happy-game`
3. **Observers**:

### Perl
1. **Director**:
2. **Maintainers**: `@ccmywish`
3. **Observers**:

### PHP
1. **Director**:
2. **Maintainers**:  `@ccmywish`
3. **Observers**:

### Go
1. **Director**:
2. **Maintainers**:  `@ccmywish`
3. **Observers**:

### Rust
1. **Director**:
2. **Maintainers**:  `@ccmywish`
3. **Observers**:

### Java
1. **Director**:
2. **Maintainers**:  `@ccmywish`
3. **Observers**:

### Clojure
1. **Director**:
2. **Maintainers**:
3. **Observers**:

### NuGet
1. **Director**:
2. **Maintainers**:
3. **Observers**:

### Dart
1. **Director**:
2. **Maintainers**:  `@ccmywish`
3. **Observers**:

### Haskell
1. **Director**:
2. **Maintainers**:  `@ccmywish`
3. **Observers**:

### OCaml
1. **Director**:
2. **Maintainers**:  `@ccmywish`
3. **Observers**:

### R
1. **Director**:
2. **Maintainers**:  `@ccmywish`
3. **Observers**:  `@gitee:tfcolin`

### Julia
1. **Director**:
2. **Maintainers**:  `@ccmywish`
3. **Observers**:

<br>

## 操作系统

### Ubuntu
1. **Director**: `@ccmywish`
2. **Maintainers**: `@gitee:G_I_Y`
3. **Observers**: `@wickdynex`

### Debian
1. **Director**:
2. **Maintainers**: `@ccmywish` `@gitee:G_I_Y`
3. **Observers**: `@happy-game`

### Fedora
1. **Director**:
2. **Maintainers**:  `@ccmywish` `@gitee:G_I_Y` `@happy-game`
3. **Observers**:

### Kali
1. **Director**:
2. **Maintainers**:  `@gitee:G_I_Y`
3. **Observers**:

### Linux Mint
1. **Director**:
2. **Maintainers**: `@ccmywish` `@gitee:G_I_Y`
3. **Observers**:

### Armbian
1. **Director**:
2. **Maintainers**:  `@ccmywish`
3. **Observers**:

### Raspberry Pi OS
1. **Director**:
2. **Maintainers**:  `@ccmywish`
3. **Observers**:

### ROS
1. **Director**:
2. **Maintainers**:  `@gitee:G_I_Y` `@ccmywish`
3. **Observers**:

### Trisquel
1. **Director**:
2. **Maintainers**: `@ccmywish`
3. **Observers**:

### Arch
1. **Director**:
2. **Maintainers**:  `@ccmywish`  `@gitee:G_I_Y` `@happy-game`
3. **Observers**:

### Manjaro
1. **Director**:
2. **Maintainers**:  `@gitee:G_I_Y` `@ccmywish`
3. **Observers**:

### msys2
1. **Director**:
2. **Maintainers**:  `@gitee:G_I_Y` `@ccmywish`
3. **Observers**:

### Alpine
1. **Director**:
2. **Maintainers**:  `@ccmywish`
3. **Observers**:

### OpenWrt
1. **Director**:
2. **Maintainers**:  `@ccmywish`
3. **Observers**: `@happy-game`

### Gentoo
1. **Director**:
2. **Maintainers**:  `@gitee:G_I_Y`
3. **Observers**:

### Void Linux
1. **Director**:
2. **Maintainers**:  `@ccmywish`
3. **Observers**:

### deepin
1. **Director**:
2. **Maintainers**:  `@gitee:G_I_Y`
3. **Observers**:

### OpenKylin
1. **Director**:
2. **Maintainers**:  `@gitee:G_I_Y`
3. **Observers**:

### OpenEuler
1. **Director**:
2. **Maintainers**:  `@gitee:G_I_Y`
3. **Observers**:

### FreeBSD
1. **Director**:
2. **Maintainers**:  `@gitee:G_I_Y` `@ccmywish`
3. **Observers**: `@ykla`

### NetBSD
1. **Director**:
2. **Maintainers**:  `@gitee:G_I_Y` `@ccmywish`
3. **Observers**:

### OpenBSD
1. **Director**:
2. **Maintainers**:  `@gitee:G_I_Y` `@ccmywish`
3. **Observers**:


<br>

## 软件

### Homebrew
1. **Director**:
2. **Maintainers**: `@ccmywish`
3. **Observers**: `@wickdynex`

### WinGet
1. **Director**:
2. **Maintainers**: `@ccmywish`
3. **Observers**:

### Flathub
1. **Director**:
2. **Maintainers**: `@ccmywish`
3. **Observers**:

### Nix
1. **Director**:
2. **Maintainers**: `@ccmywish`
3. **Observers**:

### Guix
1. **Director**:
2. **Maintainers**: `@ccmywish`
3. **Observers**:

### CocoaPods
1. **Director**:
2. **Maintainers**: `@ccmywish`
3. **Observers**:

### Docker Hub
1. **Director**:
2. **Maintainers**: `@ccmywish` `@happy-game`
3. **Observers**:

### Anaconda
1. **Director**:
2. **Maintainers**: `@ccmywish`
3. **Observers**: `@happy-game`

### Emacs
1. **Director**:
2. **Maintainers**: `@ccmywish`
3. **Observers**:

### Tex Live
1. **Director**:
2. **Maintainers**: `@ccmywish`
3. **Observers**:

<br>
